Bug 1088986 (CVE-2014-0182) - CVE-2014-0182 qemu: virtio: out-of-bounds buffer write on state load with invalid config_len
Summary: CVE-2014-0182 qemu: virtio: out-of-bounds buffer write on state load with inv...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2014-0182
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1095779 1095780 1095781 1095782 1095783 1102579 1102580 1110194 1110284 1110288 1133850
Blocks: 1036654 1110626 1133827
TreeView+ depends on / blocked
 
Reported: 2014-04-17 15:00 UTC by Petr Matousek
Modified: 2019-09-29 13:16 UTC (History)
42 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-09-22 11:09:50 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:0674 normal SHIPPED_LIVE Moderate: rhev-hypervisor6 3.4.0 security, bug fix, and enhancement update 2014-06-09 18:35:12 UTC
Red Hat Product Errata RHSA-2014:0743 normal SHIPPED_LIVE Moderate: qemu-kvm security and bug fix update 2014-06-11 00:14:13 UTC
Red Hat Product Errata RHSA-2014:0744 normal SHIPPED_LIVE Moderate: qemu-kvm-rhev security update 2014-06-11 00:14:07 UTC
Red Hat Product Errata RHSA-2014:0888 normal SHIPPED_LIVE Moderate: qemu-kvm-rhev security update 2014-07-24 19:38:25 UTC
Red Hat Product Errata RHSA-2014:0927 normal SHIPPED_LIVE Moderate: qemu-kvm security and bug fix update 2014-07-23 20:15:13 UTC
Red Hat Product Errata RHSA-2014:1268 normal SHIPPED_LIVE Moderate: qemu-kvm-rhev security update 2014-09-22 08:00:39 UTC

Description Petr Matousek 2014-04-17 15:00:55 UTC
config_len is read during state load and later used as size argument
when initializing vdev->config as follows:

hw/virtio/virtio.c: virtio_load()

    vdev->config_len = qemu_get_be32(f);
    qemu_get_buffer(f, vdev->config, vdev->config_len);


An user able to alter the savevm data (either on the disk or over the wire
during migration) could use this flaw to to corrupt QEMU process memory on
the (destination) host, which could potentially result in arbitrary code
execution on the host with the privileges of the QEMU process.

Upstream fix:
-------------
  -> http://git.qemu.org/?p=qemu.git;a=commit;h=a890a2f9137ac3cf5b607649e66a6f3a5512d8dc

Comment 1 Petr Matousek 2014-04-17 15:01:48 UTC
Statement:

This issue does affect the versions of kvm package as shipped with
Red Hat Enterprise Linux 5.

This issue does affect the versions of qemu-kvm package as shipped with
Red Hat Enterprise Linux 7.

Comment 3 Prasad J Pandit 2014-05-08 13:51:42 UTC
Created qemu tracking bugs for this issue:

Affects: fedora-all [bug 1095781]

Comment 4 Fedora Update System 2014-05-16 09:58:06 UTC
qemu-1.6.2-5.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 6 errata-xmlrpc 2014-06-09 14:37:53 UTC
This issue has been addressed in following products:

  RHEV-H and Agents for RHEL-6

Via RHSA-2014:0674 https://rhn.redhat.com/errata/RHSA-2014-0674.html

Comment 7 Murray McAllister 2014-06-10 07:56:51 UTC
Acknowledgements:

The issues were discovered as part of the state loading code audit performed by Michael S. Tsirkin of Red Hat, Anthony Liguori and Michael Roth.

Comment 8 errata-xmlrpc 2014-06-10 20:19:30 UTC
This issue has been addressed in following products:

  RHEV-H and Agents for RHEL-6

Via RHSA-2014:0744 https://rhn.redhat.com/errata/RHSA-2014-0744.html

Comment 9 errata-xmlrpc 2014-06-10 20:20:26 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2014:0743 https://rhn.redhat.com/errata/RHSA-2014-0743.html

Comment 13 Dr. David Alan Gilbert 2014-06-30 10:19:53 UTC
Please note that this fix causes a regression (see bz 1113009) which has a fix on that bz.

Comment 14 errata-xmlrpc 2014-07-23 16:16:21 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 7

Via RHSA-2014:0927 https://rhn.redhat.com/errata/RHSA-2014-0927.html

Comment 16 errata-xmlrpc 2014-07-24 15:39:26 UTC
This issue has been addressed in following products:

  OpenStack 4 for RHEL 6
  OpenStack 3 for RHEL 6

Via RHSA-2014:0888 https://rhn.redhat.com/errata/RHSA-2014-0888.html

Comment 18 errata-xmlrpc 2014-09-22 04:01:51 UTC
This issue has been addressed in the following products:

  OpenStack 5 for RHEL 7

Via RHSA-2014:1268 https://rhn.redhat.com/errata/RHSA-2014-1268.html


Note You need to log in before you can comment on or make changes to this bug.